<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChargedForResources StructType
 * @subpackage Structs
 */
class ChargedForResources extends AbstractStructBase
{
    /**
     * The charged_for_resources
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $charged_for_resources;
    /**
     * The by_heating
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_heating;
    /**
     * The by_electro
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_electro;
    /**
     * The by_gaz
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_gaz;
    /**
     * The by_hot_water
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_hot_water;
    /**
     * The by_cold_water
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_cold_water;
    /**
     * The by_sewerage
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_sewerage;
    /**
     * Constructor method for ChargedForResources
     * @uses ChargedForResources::setCharged_for_resources()
     * @uses ChargedForResources::setBy_heating()
     * @uses ChargedForResources::setBy_electro()
     * @uses ChargedForResources::setBy_gaz()
     * @uses ChargedForResources::setBy_hot_water()
     * @uses ChargedForResources::setBy_cold_water()
     * @uses ChargedForResources::setBy_sewerage()
     * @param float $charged_for_resources
     * @param float $by_heating
     * @param float $by_electro
     * @param float $by_gaz
     * @param float $by_hot_water
     * @param float $by_cold_water
     * @param float $by_sewerage
     */
    public function __construct($charged_for_resources = null, $by_heating = null, $by_electro = null, $by_gaz = null, $by_hot_water = null, $by_cold_water = null, $by_sewerage = null)
    {
        $this
            ->setCharged_for_resources($charged_for_resources)
            ->setBy_heating($by_heating)
            ->setBy_electro($by_electro)
            ->setBy_gaz($by_gaz)
            ->setBy_hot_water($by_hot_water)
            ->setBy_cold_water($by_cold_water)
            ->setBy_sewerage($by_sewerage);
    }
    /**
     * Get charged_for_resources value
     * @return float|null
     */
    public function getCharged_for_resources()
    {
        return $this->charged_for_resources;
    }
    /**
     * Set charged_for_resources value
     * @param float $charged_for_resources
     * @return \StructType\ChargedForResources
     */
    public function setCharged_for_resources($charged_for_resources = null)
    {
        // validation for constraint: float
        if (!is_null($charged_for_resources) && !(is_float($charged_for_resources) || is_numeric($charged_for_resources))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($charged_for_resources, true), gettype($charged_for_resources)), __LINE__);
        }
        $this->charged_for_resources = $charged_for_resources;
        return $this;
    }
    /**
     * Get by_heating value
     * @return float|null
     */
    public function getBy_heating()
    {
        return $this->by_heating;
    }
    /**
     * Set by_heating value
     * @param float $by_heating
     * @return \StructType\ChargedForResources
     */
    public function setBy_heating($by_heating = null)
    {
        // validation for constraint: float
        if (!is_null($by_heating) && !(is_float($by_heating) || is_numeric($by_heating))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_heating, true), gettype($by_heating)), __LINE__);
        }
        $this->by_heating = $by_heating;
        return $this;
    }
    /**
     * Get by_electro value
     * @return float|null
     */
    public function getBy_electro()
    {
        return $this->by_electro;
    }
    /**
     * Set by_electro value
     * @param float $by_electro
     * @return \StructType\ChargedForResources
     */
    public function setBy_electro($by_electro = null)
    {
        // validation for constraint: float
        if (!is_null($by_electro) && !(is_float($by_electro) || is_numeric($by_electro))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_electro, true), gettype($by_electro)), __LINE__);
        }
        $this->by_electro = $by_electro;
        return $this;
    }
    /**
     * Get by_gaz value
     * @return float|null
     */
    public function getBy_gaz()
    {
        return $this->by_gaz;
    }
    /**
     * Set by_gaz value
     * @param float $by_gaz
     * @return \StructType\ChargedForResources
     */
    public function setBy_gaz($by_gaz = null)
    {
        // validation for constraint: float
        if (!is_null($by_gaz) && !(is_float($by_gaz) || is_numeric($by_gaz))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_gaz, true), gettype($by_gaz)), __LINE__);
        }
        $this->by_gaz = $by_gaz;
        return $this;
    }
    /**
     * Get by_hot_water value
     * @return float|null
     */
    public function getBy_hot_water()
    {
        return $this->by_hot_water;
    }
    /**
     * Set by_hot_water value
     * @param float $by_hot_water
     * @return \StructType\ChargedForResources
     */
    public function setBy_hot_water($by_hot_water = null)
    {
        // validation for constraint: float
        if (!is_null($by_hot_water) && !(is_float($by_hot_water) || is_numeric($by_hot_water))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_hot_water, true), gettype($by_hot_water)), __LINE__);
        }
        $this->by_hot_water = $by_hot_water;
        return $this;
    }
    /**
     * Get by_cold_water value
     * @return float|null
     */
    public function getBy_cold_water()
    {
        return $this->by_cold_water;
    }
    /**
     * Set by_cold_water value
     * @param float $by_cold_water
     * @return \StructType\ChargedForResources
     */
    public function setBy_cold_water($by_cold_water = null)
    {
        // validation for constraint: float
        if (!is_null($by_cold_water) && !(is_float($by_cold_water) || is_numeric($by_cold_water))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_cold_water, true), gettype($by_cold_water)), __LINE__);
        }
        $this->by_cold_water = $by_cold_water;
        return $this;
    }
    /**
     * Get by_sewerage value
     * @return float|null
     */
    public function getBy_sewerage()
    {
        return $this->by_sewerage;
    }
    /**
     * Set by_sewerage value
     * @param float $by_sewerage
     * @return \StructType\ChargedForResources
     */
    public function setBy_sewerage($by_sewerage = null)
    {
        // validation for constraint: float
        if (!is_null($by_sewerage) && !(is_float($by_sewerage) || is_numeric($by_sewerage))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_sewerage, true), gettype($by_sewerage)), __LINE__);
        }
        $this->by_sewerage = $by_sewerage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ChargedForResources
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
