<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CountDismissed StructType
 * @subpackage Structs
 */
class CountDismissed extends AbstractStructBase
{
    /**
     * The count_dismissed
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $count_dismissed;
    /**
     * The count_dismissed_admins
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $count_dismissed_admins;
    /**
     * The count_dismissed_engineers
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $count_dismissed_engineers;
    /**
     * The count_dismissed_workers
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $count_dismissed_workers;
    /**
     * Constructor method for CountDismissed
     * @uses CountDismissed::setCount_dismissed()
     * @uses CountDismissed::setCount_dismissed_admins()
     * @uses CountDismissed::setCount_dismissed_engineers()
     * @uses CountDismissed::setCount_dismissed_workers()
     * @param int $count_dismissed
     * @param int $count_dismissed_admins
     * @param int $count_dismissed_engineers
     * @param int $count_dismissed_workers
     */
    public function __construct($count_dismissed = null, $count_dismissed_admins = null, $count_dismissed_engineers = null, $count_dismissed_workers = null)
    {
        $this
            ->setCount_dismissed($count_dismissed)
            ->setCount_dismissed_admins($count_dismissed_admins)
            ->setCount_dismissed_engineers($count_dismissed_engineers)
            ->setCount_dismissed_workers($count_dismissed_workers);
    }
    /**
     * Get count_dismissed value
     * @return int|null
     */
    public function getCount_dismissed()
    {
        return $this->count_dismissed;
    }
    /**
     * Set count_dismissed value
     * @param int $count_dismissed
     * @return \StructType\CountDismissed
     */
    public function setCount_dismissed($count_dismissed = null)
    {
        // validation for constraint: int
        if (!is_null($count_dismissed) && !(is_int($count_dismissed) || ctype_digit($count_dismissed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count_dismissed, true), gettype($count_dismissed)), __LINE__);
        }
        $this->count_dismissed = $count_dismissed;
        return $this;
    }
    /**
     * Get count_dismissed_admins value
     * @return int|null
     */
    public function getCount_dismissed_admins()
    {
        return $this->count_dismissed_admins;
    }
    /**
     * Set count_dismissed_admins value
     * @param int $count_dismissed_admins
     * @return \StructType\CountDismissed
     */
    public function setCount_dismissed_admins($count_dismissed_admins = null)
    {
        // validation for constraint: int
        if (!is_null($count_dismissed_admins) && !(is_int($count_dismissed_admins) || ctype_digit($count_dismissed_admins))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count_dismissed_admins, true), gettype($count_dismissed_admins)), __LINE__);
        }
        $this->count_dismissed_admins = $count_dismissed_admins;
        return $this;
    }
    /**
     * Get count_dismissed_engineers value
     * @return int|null
     */
    public function getCount_dismissed_engineers()
    {
        return $this->count_dismissed_engineers;
    }
    /**
     * Set count_dismissed_engineers value
     * @param int $count_dismissed_engineers
     * @return \StructType\CountDismissed
     */
    public function setCount_dismissed_engineers($count_dismissed_engineers = null)
    {
        // validation for constraint: int
        if (!is_null($count_dismissed_engineers) && !(is_int($count_dismissed_engineers) || ctype_digit($count_dismissed_engineers))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count_dismissed_engineers, true), gettype($count_dismissed_engineers)), __LINE__);
        }
        $this->count_dismissed_engineers = $count_dismissed_engineers;
        return $this;
    }
    /**
     * Get count_dismissed_workers value
     * @return int|null
     */
    public function getCount_dismissed_workers()
    {
        return $this->count_dismissed_workers;
    }
    /**
     * Set count_dismissed_workers value
     * @param int $count_dismissed_workers
     * @return \StructType\CountDismissed
     */
    public function setCount_dismissed_workers($count_dismissed_workers = null)
    {
        // validation for constraint: int
        if (!is_null($count_dismissed_workers) && !(is_int($count_dismissed_workers) || ctype_digit($count_dismissed_workers))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count_dismissed_workers, true), gettype($count_dismissed_workers)), __LINE__);
        }
        $this->count_dismissed_workers = $count_dismissed_workers;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CountDismissed
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
