<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CountHousesUnderMngReportDate StructType
 * @subpackage Structs
 */
class CountHousesUnderMngReportDate extends AbstractStructBase
{
    /**
     * The count_houses_under_mng_report_date
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $count_houses_under_mng_report_date;
    /**
     * The serviced_by_tsg
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $serviced_by_tsg;
    /**
     * The serviced_by_tsg_uo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $serviced_by_tsg_uo;
    /**
     * The serviced_by_owner_uo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $serviced_by_owner_uo;
    /**
     * The serviced_by_competition
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $serviced_by_competition;
    /**
     * Constructor method for CountHousesUnderMngReportDate
     * @uses CountHousesUnderMngReportDate::setCount_houses_under_mng_report_date()
     * @uses CountHousesUnderMngReportDate::setServiced_by_tsg()
     * @uses CountHousesUnderMngReportDate::setServiced_by_tsg_uo()
     * @uses CountHousesUnderMngReportDate::setServiced_by_owner_uo()
     * @uses CountHousesUnderMngReportDate::setServiced_by_competition()
     * @param int $count_houses_under_mng_report_date
     * @param int $serviced_by_tsg
     * @param int $serviced_by_tsg_uo
     * @param int $serviced_by_owner_uo
     * @param int $serviced_by_competition
     */
    public function __construct($count_houses_under_mng_report_date = null, $serviced_by_tsg = null, $serviced_by_tsg_uo = null, $serviced_by_owner_uo = null, $serviced_by_competition = null)
    {
        $this
            ->setCount_houses_under_mng_report_date($count_houses_under_mng_report_date)
            ->setServiced_by_tsg($serviced_by_tsg)
            ->setServiced_by_tsg_uo($serviced_by_tsg_uo)
            ->setServiced_by_owner_uo($serviced_by_owner_uo)
            ->setServiced_by_competition($serviced_by_competition);
    }
    /**
     * Get count_houses_under_mng_report_date value
     * @return int|null
     */
    public function getCount_houses_under_mng_report_date()
    {
        return $this->count_houses_under_mng_report_date;
    }
    /**
     * Set count_houses_under_mng_report_date value
     * @param int $count_houses_under_mng_report_date
     * @return \StructType\CountHousesUnderMngReportDate
     */
    public function setCount_houses_under_mng_report_date($count_houses_under_mng_report_date = null)
    {
        // validation for constraint: int
        if (!is_null($count_houses_under_mng_report_date) && !(is_int($count_houses_under_mng_report_date) || ctype_digit($count_houses_under_mng_report_date))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count_houses_under_mng_report_date, true), gettype($count_houses_under_mng_report_date)), __LINE__);
        }
        $this->count_houses_under_mng_report_date = $count_houses_under_mng_report_date;
        return $this;
    }
    /**
     * Get serviced_by_tsg value
     * @return int|null
     */
    public function getServiced_by_tsg()
    {
        return $this->serviced_by_tsg;
    }
    /**
     * Set serviced_by_tsg value
     * @param int $serviced_by_tsg
     * @return \StructType\CountHousesUnderMngReportDate
     */
    public function setServiced_by_tsg($serviced_by_tsg = null)
    {
        // validation for constraint: int
        if (!is_null($serviced_by_tsg) && !(is_int($serviced_by_tsg) || ctype_digit($serviced_by_tsg))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviced_by_tsg, true), gettype($serviced_by_tsg)), __LINE__);
        }
        $this->serviced_by_tsg = $serviced_by_tsg;
        return $this;
    }
    /**
     * Get serviced_by_tsg_uo value
     * @return int|null
     */
    public function getServiced_by_tsg_uo()
    {
        return $this->serviced_by_tsg_uo;
    }
    /**
     * Set serviced_by_tsg_uo value
     * @param int $serviced_by_tsg_uo
     * @return \StructType\CountHousesUnderMngReportDate
     */
    public function setServiced_by_tsg_uo($serviced_by_tsg_uo = null)
    {
        // validation for constraint: int
        if (!is_null($serviced_by_tsg_uo) && !(is_int($serviced_by_tsg_uo) || ctype_digit($serviced_by_tsg_uo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviced_by_tsg_uo, true), gettype($serviced_by_tsg_uo)), __LINE__);
        }
        $this->serviced_by_tsg_uo = $serviced_by_tsg_uo;
        return $this;
    }
    /**
     * Get serviced_by_owner_uo value
     * @return int|null
     */
    public function getServiced_by_owner_uo()
    {
        return $this->serviced_by_owner_uo;
    }
    /**
     * Set serviced_by_owner_uo value
     * @param int $serviced_by_owner_uo
     * @return \StructType\CountHousesUnderMngReportDate
     */
    public function setServiced_by_owner_uo($serviced_by_owner_uo = null)
    {
        // validation for constraint: int
        if (!is_null($serviced_by_owner_uo) && !(is_int($serviced_by_owner_uo) || ctype_digit($serviced_by_owner_uo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviced_by_owner_uo, true), gettype($serviced_by_owner_uo)), __LINE__);
        }
        $this->serviced_by_owner_uo = $serviced_by_owner_uo;
        return $this;
    }
    /**
     * Get serviced_by_competition value
     * @return int|null
     */
    public function getServiced_by_competition()
    {
        return $this->serviced_by_competition;
    }
    /**
     * Set serviced_by_competition value
     * @param int $serviced_by_competition
     * @return \StructType\CountHousesUnderMngReportDate
     */
    public function setServiced_by_competition($serviced_by_competition = null)
    {
        // validation for constraint: int
        if (!is_null($serviced_by_competition) && !(is_int($serviced_by_competition) || ctype_digit($serviced_by_competition))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviced_by_competition, true), gettype($serviced_by_competition)), __LINE__);
        }
        $this->serviced_by_competition = $serviced_by_competition;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CountHousesUnderMngReportDate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
