<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PayedKuByStatements StructType
 * @subpackage Structs
 */
class PayedKuByStatements extends AbstractStructBase
{
    /**
     * The payed_ku_by_statements
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $payed_ku_by_statements;
    /**
     * The by_heating
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_heating;
    /**
     * The by_electro
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_electro;
    /**
     * The by_gaz
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_gaz;
    /**
     * The by_hot_water
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_hot_water;
    /**
     * The by_cold_water
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_cold_water;
    /**
     * Constructor method for PayedKuByStatements
     * @uses PayedKuByStatements::setPayed_ku_by_statements()
     * @uses PayedKuByStatements::setBy_heating()
     * @uses PayedKuByStatements::setBy_electro()
     * @uses PayedKuByStatements::setBy_gaz()
     * @uses PayedKuByStatements::setBy_hot_water()
     * @uses PayedKuByStatements::setBy_cold_water()
     * @param float $payed_ku_by_statements
     * @param float $by_heating
     * @param float $by_electro
     * @param float $by_gaz
     * @param float $by_hot_water
     * @param float $by_cold_water
     */
    public function __construct($payed_ku_by_statements = null, $by_heating = null, $by_electro = null, $by_gaz = null, $by_hot_water = null, $by_cold_water = null)
    {
        $this
            ->setPayed_ku_by_statements($payed_ku_by_statements)
            ->setBy_heating($by_heating)
            ->setBy_electro($by_electro)
            ->setBy_gaz($by_gaz)
            ->setBy_hot_water($by_hot_water)
            ->setBy_cold_water($by_cold_water);
    }
    /**
     * Get payed_ku_by_statements value
     * @return float|null
     */
    public function getPayed_ku_by_statements()
    {
        return $this->payed_ku_by_statements;
    }
    /**
     * Set payed_ku_by_statements value
     * @param float $payed_ku_by_statements
     * @return \StructType\PayedKuByStatements
     */
    public function setPayed_ku_by_statements($payed_ku_by_statements = null)
    {
        // validation for constraint: float
        if (!is_null($payed_ku_by_statements) && !(is_float($payed_ku_by_statements) || is_numeric($payed_ku_by_statements))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($payed_ku_by_statements, true), gettype($payed_ku_by_statements)), __LINE__);
        }
        $this->payed_ku_by_statements = $payed_ku_by_statements;
        return $this;
    }
    /**
     * Get by_heating value
     * @return float|null
     */
    public function getBy_heating()
    {
        return $this->by_heating;
    }
    /**
     * Set by_heating value
     * @param float $by_heating
     * @return \StructType\PayedKuByStatements
     */
    public function setBy_heating($by_heating = null)
    {
        // validation for constraint: float
        if (!is_null($by_heating) && !(is_float($by_heating) || is_numeric($by_heating))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_heating, true), gettype($by_heating)), __LINE__);
        }
        $this->by_heating = $by_heating;
        return $this;
    }
    /**
     * Get by_electro value
     * @return float|null
     */
    public function getBy_electro()
    {
        return $this->by_electro;
    }
    /**
     * Set by_electro value
     * @param float $by_electro
     * @return \StructType\PayedKuByStatements
     */
    public function setBy_electro($by_electro = null)
    {
        // validation for constraint: float
        if (!is_null($by_electro) && !(is_float($by_electro) || is_numeric($by_electro))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_electro, true), gettype($by_electro)), __LINE__);
        }
        $this->by_electro = $by_electro;
        return $this;
    }
    /**
     * Get by_gaz value
     * @return float|null
     */
    public function getBy_gaz()
    {
        return $this->by_gaz;
    }
    /**
     * Set by_gaz value
     * @param float $by_gaz
     * @return \StructType\PayedKuByStatements
     */
    public function setBy_gaz($by_gaz = null)
    {
        // validation for constraint: float
        if (!is_null($by_gaz) && !(is_float($by_gaz) || is_numeric($by_gaz))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_gaz, true), gettype($by_gaz)), __LINE__);
        }
        $this->by_gaz = $by_gaz;
        return $this;
    }
    /**
     * Get by_hot_water value
     * @return float|null
     */
    public function getBy_hot_water()
    {
        return $this->by_hot_water;
    }
    /**
     * Set by_hot_water value
     * @param float $by_hot_water
     * @return \StructType\PayedKuByStatements
     */
    public function setBy_hot_water($by_hot_water = null)
    {
        // validation for constraint: float
        if (!is_null($by_hot_water) && !(is_float($by_hot_water) || is_numeric($by_hot_water))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_hot_water, true), gettype($by_hot_water)), __LINE__);
        }
        $this->by_hot_water = $by_hot_water;
        return $this;
    }
    /**
     * Get by_cold_water value
     * @return float|null
     */
    public function getBy_cold_water()
    {
        return $this->by_cold_water;
    }
    /**
     * Set by_cold_water value
     * @param float $by_cold_water
     * @return \StructType\PayedKuByStatements
     */
    public function setBy_cold_water($by_cold_water = null)
    {
        // validation for constraint: float
        if (!is_null($by_cold_water) && !(is_float($by_cold_water) || is_numeric($by_cold_water))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_cold_water, true), gettype($by_cold_water)), __LINE__);
        }
        $this->by_cold_water = $by_cold_water;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PayedKuByStatements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
