<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetRequestForSubmitInnStatus StructType
 * @subpackage Structs
 */
class SetRequestForSubmitInnStatus extends AbstractStructBase
{
    /**
     * The inn
     * @var string
     */
    public $inn;
    /**
     * The status
     * @var string
     */
    public $status;
    /**
     * Constructor method for SetRequestForSubmitInnStatus
     * @uses SetRequestForSubmitInnStatus::setInn()
     * @uses SetRequestForSubmitInnStatus::setStatus()
     * @param string $inn
     * @param string $status
     */
    public function __construct($inn = null, $status = null)
    {
        $this
            ->setInn($inn)
            ->setStatus($status);
    }
    /**
     * Get inn value
     * @return string|null
     */
    public function getInn()
    {
        return $this->inn;
    }
    /**
     * Set inn value
     * @param string $inn
     * @return \StructType\SetRequestForSubmitInnStatus
     */
    public function setInn($inn = null)
    {
        // validation for constraint: string
        if (!is_null($inn) && !is_string($inn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inn, true), gettype($inn)), __LINE__);
        }
        $this->inn = $inn;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @uses \EnumType\SetRequestForSubmitInnStatusEnum::valueIsValid()
     * @uses \EnumType\SetRequestForSubmitInnStatusEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $status
     * @return \StructType\SetRequestForSubmitInnStatus
     */
    public function setStatus($status = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SetRequestForSubmitInnStatusEnum::valueIsValid($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SetRequestForSubmitInnStatusEnum', is_array($status) ? implode(', ', $status) : var_export($status, true), implode(', ', \EnumType\SetRequestForSubmitInnStatusEnum::getValidValues())), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetRequestForSubmitInnStatus
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
